<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Сотрудники
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="active" slot-scope="data">
          {{ data.item.active ? 'Активный' : 'Не активный' }}
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="items.length" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование сотрудника" centered @ok="edit" ok-only>
      <h6>Сотрудник: {{modalInfo.name}} {{modalInfo.lastName}}</h6>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <input type="text" v-validate="'required'" name="name2" placeholder="Имя" v-model="modalInfo.name" class="form-control"></input>
          <span v-show="errors.has('name2')" class="text-danger">{{ errors.first('name2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <b-form-input type="text" v-validate="'required'" name="lastName2" placeholder="Фамилия" v-model="modalInfo.lastName"></b-form-input>
          <span v-show="errors.has('lastName2')" class="text-danger">{{ errors.first('lastName2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Должность</label>
          <b-form-select v-model="modalInfo.position" :options="positions" v-validate="'required'" name="position2"></b-form-select>
          <span v-show="errors.has('position2')" class="text-danger">{{ errors.first('position2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Департамент</label>
          <b-form-input type="text" name="department2" placeholder="Департамент" v-validate="'required'" v-model="modalInfo.department"></b-form-input>
          <span v-show="errors.has('department2')" class="text-danger">{{ errors.first('department2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input v-model="modalInfo.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" v-validate="'required'" name="phone2"></masked-input>
          <span v-show="errors.has('phone2')" class="text-danger">{{ errors.first('phone2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Статус</label>
          <b-form-select v-model="modalInfo.active" :options="active"></b-form-select>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" @click.prevent="$validator.validateAll()" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
    <b-modal id="addingModal" @hide="resetModal" title="Добавление сотрудника" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <input type="text" class="form-control" name="name" v-validate="'required'" placeholder="Имя" v-model="addedUser.name"></input>
          <span v-show="errors.has('name')" class="text-danger">{{ errors.first('name') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <input type="text" class="form-control" v-validate="'required'" name="lastName" placeholder="Фамилия" v-model="addedUser.lastName"></input>
          <span v-show="errors.has('lastName')" class="text-danger">{{ errors.first('lastName') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Должность</label>
          <b-form-select class="form-control" v-validate="'required'" name="position" v-model="addedUser.position" :options="positions"></b-form-select>
          <span v-show="errors.has('position')" class="text-danger">{{ errors.first('position') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Департамент</label>
          <input type="text" class="form-control" v-validate="'required'" name="department" placeholder="Департамент" v-model="addedUser.department"></input>
          <span v-show="errors.has('department')" class="text-danger">{{ errors.first('department') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input v-model="addedUser.phone" v-validate="'required'" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон"  name="phone"></masked-input>
          <span v-show="errors.has('phone')" class="text-danger">{{ errors.first('phone') }}</span>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" @click.prevent="$validator.validateAll()" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'
import MaskedInput from 'vue-masked-input'

export default {
  name: 'Employees',
  components: {
    Datepicker,
    MaskedInput
  },
  props: {
    caption: {
      type: String,
      default: 'Сотрудники'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      ru: ru,
      items: [],
      positions: [],
      cities: [],
      active: [
        { value: true, text: 'Активный'},
        { value: false, text: 'Не активный'}
      ],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'lastName', sortable: true, label: 'Фамилия' },
        { key: 'position', sortable: true, label: 'Должность' },
        { key: 'department', sortable: true, label: 'Департамент' },
        { key: 'phone', sortable: true, label: 'Телефон' },
        { key: 'active', sortable: true, label: 'Статус' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      filter: null,
      rowCount: 1,
      modalInfo: {
        id: '',
        name: '',
        lastName: '',
        position: '',
        department: '',
        phone: '',
        active: '',
      },
      addedUser: {
        name: '',
        lastName: '',
        position: '',
        department: '',
        phone: '',
        type: 'employee',
        status: 'active'
      }
    }
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getCities () {
      Api().get('getCities').then(response => {
        this.cities = response.data.map(item => {
          return { value: item.name, text: item.name }
        })
      })
    },
    getUsers () {
      Api().post('getByParameters', {type: 'employee'}).then(response => {
        this.items = response.data
      })
    },
    getPositions () {
      Api().get('positions').then(response => {
        this.positions = response.data.map(item => {
          return { value: item.name, text: item.name }
        })
      })
    },
    adding (e) {
      this.$validator.validateAll()
      if (this.validateAdding()) {
        this.addedUser.type = 'employee'
        this.addedUser.phone = this.addedUser.phone.replace(/\D+/g, "")
        Api().post('adduser', this.addedUser).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    edit (e) {
      this.$validator.validateAll()
      if (this.validateEditing()) {
        this.modalInfo.phone = this.modalInfo.phone.replace(/\D+/g, "")
        Api().post('edituser', this.modalInfo).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletingusers', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    validateAdding () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0 && this.addedUser.position.length > 0
        && this.addedUser.department.length > 0 && this.addedUser.phone.length > 0) {
        return true
      } else {
        return false
      }
    },
    validateEditing () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0 && this.modalInfo.position.length > 0
        && this.modalInfo.department.length > 0 && this.modalInfo.phone.length > 0) {
        return true
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    dateFormat (_date) {
      function fmt (n) {
        return n > 9 ? n : '0' + n
      }
      const now = new Date(_date.trim())
      if (now != 'Invalid Date') {
        _date = fmt(now.getDate()) + '.' + fmt(now.getMonth() + 1) + '.' + fmt(now.getFullYear())
        const time = fmt(now.getHours()) + ':' +  fmt(now.getMinutes())
      }

      return _date
    },
    resetModal () {
      this.modalInfo.title = ''
      this.modalInfo.content = ''
      this.addedUser.login = ''
      this.addedUser.name = ''
      this.addedUser.lastName = ''
      this.addedUser.position = ''
      this.addedUser.department = ''
      this.addedUser.phone = ''
      this.addedUser.email = ''
      this.addedUser.birthday = ''
      this.errors.clear()
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  },
  created () {
    this.getCities()
    this.getUsers()
    this.getPositions()
  }
}
</script>
